#include <Wire.h>                           // Tinclude the 12 lib, this one is standard Arduino Package

// Motor A

int enA = 9;
int in1 = 8;
int in2 = 7;

// Motor B

int enB = 3;
int in3 = 5;
int in4 = 4;


//Speed Control Pressure Sensors

int Sensor1 = A0;
int Sensor2 = A2;
int Sensor3 = A1;

// Motor Speed Values

int MotorSpeed1 = 0; 
int MotorSpeed2 = 0;


//Defining Distance Sensor Pins

#define FrontEcho 13
#define FrontTrigger 2
#define BackEcho 11
#define BackTrigger 12



void setup() {
 pinMode (enA, OUTPUT);                     // Setting up the H Bridge
 pinMode (in1, OUTPUT);                     
 pinMode (in2, OUTPUT);
 pinMode (enB, OUTPUT);
 pinMode (in3, OUTPUT);
 pinMode (in4, OUTPUT);
 pinMode (FrontEcho,INPUT);                 // Setting up the Front Ultrasonic Sensor
 pinMode (FrontTrigger, OUTPUT);
 pinMode (BackEcho, INPUT);                 // Setting up the Back Ultrasonic Sensor
 pinMode (BackTrigger, OUTPUT);

 Serial.begin(9600);
}  


void loop(){

    // Initializing Pressure Sensors
    
    int Sensor1Reading = analogRead(Sensor1); 
    int Sensor2Reading = analogRead(Sensor2);  
    int Sensor3Reading = analogRead(Sensor3);

    //Initializing Front Distance Sensor

    digitalWrite (FrontTrigger, HIGH);               // Actual signal being read
    delayMicroseconds(10);
    digitalWrite (FrontTrigger, LOW);
        
    int distanceF = pulseIn (FrontEcho, HIGH);       // Reading pulse
        
    distanceF = distanceF/58;                        // Converting from ms to cm 

    //Initializing Front Distance Sensor

    digitalWrite (BackTrigger, HIGH);                // Actual signal being read
    delayMicroseconds(10);
    digitalWrite (BackTrigger, LOW);
        
    int distanceB = pulseIn (BackEcho, HIGH);        // Reading pulse
        
    distanceB = distanceB/58;                        // Converting from ms to cm   

    // Initial Check of Sensors on Serial Monitor
    
    Serial.print ("Sensor1Reading: ");
    Serial.println(Sensor1Reading);
    Serial.print("Sensor2Reading: ");
    Serial.println(Sensor2Reading);
    Serial.println(  );
    Serial.print ("Sensor3Reading:");
    Serial.println(Sensor3Reading);
    Serial.println( );
    Serial.print ("Distance Front: ");
    Serial.println(distanceF);
    Serial.print ("Distance Back: ");
    Serial.println (distanceB);
    Serial.println(  );
    
    // Ouch @ sensor 1
    
      if (Sensor1Reading > 100) {                  // Accounting for pressure from surrounding air

       if (Sensor1Reading > 900){                  // Minimum Pressure Applied to Activate

        if(distanceF <= 20){

        //Distance Sensor
        
        digitalWrite (FrontTrigger, HIGH);         // Actual signal being read
        delayMicroseconds(10);
        digitalWrite (FrontTrigger, LOW);
        
        distanceF = pulseIn (FrontEcho, HIGH);      // Reading pulse
        
        distanceF = distanceF/58;                   // Converting from ms to cm

        // Serial check to make sure its working
        Serial.print ("Distance Motion Sensor 1: ");              
        Serial.println(distanceF);
        Serial.println(  );
       


            // Set Motor 1 forward
              digitalWrite(in1, HIGH);
              digitalWrite(in2, LOW);

            // Set Motor 2 forward
              digitalWrite(in3, HIGH);
              digitalWrite(in4, LOW);

            // Setting motors at full power
              analogWrite(enA, 1023);
              analogWrite(enB, 1023);
              
              delay(5000);
    
          }
        }
      }

     
      if (Sensor3Reading > 100) {                     // Accounting for pressure from surrounding air 
        
          if (Sensor3Reading > 900){                  // Minimum Pressure Applied to Activate
            
            if(distanceF <= 20){

             //Distance Sensor
        
              digitalWrite (FrontTrigger, HIGH);         // Actual signal being read
              delayMicroseconds(10);
              digitalWrite (FrontTrigger, LOW);
        
              distanceF = pulseIn (FrontEcho, HIGH);      // Reading pulse
        
              distanceF = distanceF/58;                   // Converting from ms to cm

              // Serial check to make sure its working
              Serial.print ("Distance Motion Sensor 3: ");              
              Serial.println(distanceF);
              Serial.println(  );


             // Set Motor 1 forward
              digitalWrite(in1, HIGH);
              digitalWrite(in2, LOW);

             // Set Motor 2 forward
              digitalWrite(in3, HIGH);
              digitalWrite(in4, LOW);
    
             // Setting motors at full power
  
              MotorSpeed1 = 1023;
              MotorSpeed2 = 1023;

              analogWrite(enA, MotorSpeed1);
              analogWrite(enB, MotorSpeed2);
              delay (5000);
          }
        }
      
      
  }


  if (Sensor2Reading > 100){                    // Accounting for pressure from surrounding air

    if (Sensor2Reading > 900){                  // Minimum Pressure Applied to Activate

        if(distanceB < 20){

         //Distance Sensor
        
          digitalWrite (BackTrigger, HIGH);                // Actual signal being read
          delayMicroseconds(10);
          digitalWrite (BackTrigger, LOW);
        
          distanceB = pulseIn (BackEcho, HIGH);            // Reading pulse
        
          distanceB = distanceB/58;                        // Converting from ms to cm

          // Serial check to make sure its working
          
          Serial.print ("Distance Motion Sensor 2: ");              
          Serial.println(distanceB);
          Serial.println(  );


         // Set Motor 1 forward
          digitalWrite(in1, LOW);
          digitalWrite(in2, HIGH);

         // Set Motor 2 forward
          digitalWrite(in3, LOW);
          digitalWrite(in4, HIGH);
    
         // Setting motors at full power
           
           MotorSpeed1 = 1023;
           MotorSpeed2 = 2013;

              analogWrite(enA, MotorSpeed1);
              analogWrite(enB, MotorSpeed2);
              
              delay (5000);
          }
        }
      }
   
// Turn Motors OFF
  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);

  digitalWrite(in3, LOW);
  digitalWrite(in4, LOW);
}
